// BruchAddiererModel.java                          MM 2015
// MVC-Model

import java.util.*;                           // Observable

/**
 * Addierer fuer gemeine Brueche, MVC-Model.
 */
public class BruchAddiererModel
  extends Observable
{
/* ------------------------------------------------------*/
                                                // coreData
/**
 * Ergebnisbruch.
 */
  private Bruch ergebnis;

/**
 * Bruchoperand.
 */
  private Bruch operand;

/* ----------------------------------------------------- */
                                             // Konstruktor
/**
 * Konstruktor, setzt Startwerte auf 0/1.
 */
  public BruchAddiererModel()
  {
    reset();
  }


/* ------------------------------------------------------*/
                                        // getData-Methoden

/* ----------------------------------------------------- */
                                        // Service-Methoden
/**
 * Setzen eines neuen Operandennenner.
 * @param n Nenner
 * @throws BruchException
 */
  public void setOperandNenner( int n)
    throws Exception
  {
    operand.setNenner( n);
  }

/**
 * Setzen eines neuen Operandenzaehler.
 * @param z Zaehler
 */
  public void setOperandZaehler( int z)
  {
    operand.setZaehler( z);
  }

/**
 * Startzustand, loeschen von Bruch und Operand.
 */
  public void reset()
  {
    ergebnis = new Bruch( 0);
    operand = new Bruch( 0);

    setChanged();                     // Aenderung anzeigen
    notifyObservers();
  }

/**
 * Addition, Bruch = Bruch + Operand.
 * @throws BruchException, NPlusException
 */
  public void addiere()
    throws Exception
  {
    ergebnis = ergebnis.add( operand);
    operand = new Bruch( 0);

    setChanged();                     // Aenderung anzeigen
    notifyObservers();
  }

/* ----------------------------------------------------- */
/**
 * Darstellung des Ergebnisbruchs.
 */
  public String toString()
  {
    return ergebnis.toString();
  }
}
